#include <fstream.h>
#include "Message.h"


ostream& 
operator <<(ostream& os, const MessHeader_t& aMessHeader_t) 
{
	switch ( aMessHeader_t.msgType )
	{
		case MSG_SCHEDULE :

			os << "(Type MSG_SCHEDULE)" ;
			break ; 
	
		case MSG_KILL :

			os << "(Type MSG_KILL)" ;
			break ;	

		case MSG_TERMINATED :

			os << "(Type MSG_TERMINATED)" ;
			break ;

		case MSG_STARTUP :

			os << "(Type MSG_STARTUP)" ;
			break ;

		case MSG_QUERY :
			os << "(Type MSG_QUERY)" ;
			break ;

		case MSG_QUERY_ANSWER :
			os << "(Type MSG_QUERY_ANSWER)" ;
			break ;

		case MSG_SUSPEND :
			os << "(Type MSG_SUSPEND)" ;
			break ;

		case MSG_RESUME :
			os << "(Type MSG_RESUME)" ;
			break ;

		case MSG_SUBMIT :
			os << "(Type MSG_SUBMIT)" ;
			break ;

		case MSG_SUBMIT_REPLY :
			os << "(Type MSG_SUBMIT_REPLY)" ;
			break ;

		case MSG_SUBMIT_COMMIT :
			os << "(Type MSG_SUBMIT_COMMIT)" ;
			break ;

		case MSG_SUBMIT_ABORT :
			os << "(Type MSG_SUBMIT_ABORT)" ;
			break ;

		case MSG_WITHDRAW :
			os << "(Type MSG_WITHDRAW)" ;
			break ;

		default :
			 assert( 0 ) ;
	}

	os << " (Address " << aMessHeader_t.ipAddress << ")" ;

	os << " (Length " << aMessHeader_t.msgLen << ")" ;

	os << " (JobId " << aMessHeader_t.jobId << ")" ;

	os << " (Entry " << aMessHeader_t.entryNum << ")" ;

	os << " (NumNodes " << aMessHeader_t.numNodes << ")" ;

	return os ;
}
