#include "GSPEntry.h"
#include "List.h"
#include <string.h> 
#include <String.h>

void
Print( oo_List<Entry_t>& entryCollect )
{
	if ( entryCollect.IsEmpty() )
		return ;

	entryCollect.StartTraversal() ;

	for ( Entry_t* tmpEntry = entryCollect.Element() ; tmpEntry ;  
		tmpEntry = !entryCollect.Advance() ? entryCollect.Element() : NULL ) 
	{
		tmpEntry->Print() ; 	
	}

	cout << "------------------------" << endl ;
}

int
Linearize( String& msg, oo_List<Entry_t>& entryCollect )
{
	if ( entryCollect.IsEmpty() )
		return -1 ;

	entryCollect.StartTraversal() ;

	for ( Entry_t* tmpEntry = entryCollect.Element() ; tmpEntry ;  
		tmpEntry = !entryCollect.Advance() ? entryCollect.Element() : NULL ) 
	{
		String submsg ;

		submsg = tmpEntry->fileName ;

		submsg += '\t' ;

		submsg += tmpEntry->parameters ;

		submsg += '\n' ; 

		// To hack around the string concatenation bug
		String tmpstr ;

		tmpstr.alloc(::strlen(msg.chars()) + ::strlen(submsg.chars())+2) ;

		::strcpy(tmpstr,msg.chars()) ;

		::strcat(tmpstr,submsg.chars()) ;

		msg = tmpstr ;
	}

	return 0 ; 
}

