#include <iostream.h>
#include <sys/param.h>
#include <String.h>

#include "Functions.h"
#include "Message.h"
#include "GSPJob.h"
#include "GSPEntry.h"
#include "List.h"

extern oo_List<Job_t>		jobList ; 

int
SingleGSPJobQuery( int querySock, int jobId ,char* myIPAddress)
{
	String ansQuery ;

	Job_t* 	tmpJob = Search( jobList, jobId );
	
	if ( tmpJob == NULL || Linearize( ansQuery, jobList, tmpJob ) < 0 )
	{
		char number[64] ;	// AMIT - Can make this a #define'd var

		ansQuery = "Job " ;

		sprintf(number,"%d ",jobId ) ;

		ansQuery += number ;  

		ansQuery += "is not in the system.\n" ;
	}

	MessHeader_t message(myIPAddress) ;

	const char* answer = ansQuery.chars() ;

	cout << answer << endl ; 

	message.ConstructQueryAnswerMessage( ::strlen(answer) ) ;   	

	if ( message.Send( querySock ) < 0 )
	{
		cerr << "Error sending message header to single job query answer : "
		     << sys_errlist[errno] << endl ;
		
		return -1 ; 
	}	
	
	// Send the answer over the querysock
	if ( write( querySock, answer, ::strlen(answer) ) < 0 )
	{
		cerr << "Error sending answer to single job query : "
		     << sys_errlist[errno] << endl ;

		return -1 ; 
	}

	return 0 ;
}

int
AllGSPJobQuery( int querySock, char* myIPAddress)
{
	String ansQuery ;

	if ( Linearize( ansQuery, jobList ) < 0 )
	{
		ansQuery = "No jobs are running in " ;

		char* hostName = GetHostName() ;	

		cout << hostName << endl ;

		ansQuery += ( hostName != NULL ? hostName : "\0" ) ;    
	}

	MessHeader_t message(myIPAddress) ;

	const char* answer = ansQuery.chars() ;

	cout << answer << endl ; 

	message.ConstructQueryAnswerMessage(::strlen(answer)) ;   	

	if ( message.Send( querySock ) < 0 )
	{
		cerr << "Error sending message header to all job query answer : "
		     << sys_errlist[errno] << endl ;
	

		return -1 ; 
	}	
	
	// Send the answer over the querysock
	if ( write( querySock, answer, ::strlen(answer) ) < 0 )
	{
		cerr << "Error sending answer to all job query : "
		     << sys_errlist[errno] << endl ;

		return -1 ; 
	}

	return 0 ;
}
