#include <stdio.h>
#include <sys/param.h>
#include "Message.h"
#include "GSPEntry.h"
#include "GSPMachine.h"
#include "GSPJob.h"


// AMIT  -  To be fixed
// WARNING: A lot of memory leakage is possible. Clean up required in the code

extern	HashTable_t			machineList ;
extern	oo_List<RunningJob_t>           runningList ;
extern	char				MyIPAddress[MAXHOSTNAMELEN] ;


/*
void
FreeAllocatedNodes( oo_List<JobLSPInfo_t>& lspList )
{
	if ( lspList.IsEmpty() )
		return ;

	lspList.StartTraversal() ;

	JobLSPInfo_t*	tmpLSPInfo = NULL ;		

	// AMIT - IS this correct ? - looks slightly shady.
	for ( tmpLSPInfo = lspList.Element() ; tmpLSPInfo ;   
	      tmpLSPInfo = !lspList.Advance() ? lspList.Element() : NULL )
	{
		tmpLSPInfo->machPtr->numProcessorsFree += tmpLSPInfo->prsrAllocated ;
	}			
}
*/

// ----------------------------------------------------------------------------------
// AllocateNodesForJob -- Given a pointer to a job, allocates the required number of 
//			  nodes and processors. Creates an entry in the running job 
//			  list and sets the status field to be scheduled  
// 			  Returns 0 on success
//			  Returns -1 otherwise
// 			  This function assumes that a particular job has been chosen 
//			  by the policy to schedule 
// ----------------------------------------------------------------------------------

int
AllocateNodesForAJob( Job_t* aJob )
{
	if ( aJob == NULL ) 
		return -1; 

	RunningJob_t	*aRJob = new RunningJob_t(aJob) ;

	if ( aRJob == NULL  )
	{
		return -1;
	}

	// Number of nodes required for the job
	int 		reqNodes = aJob->numNodesRequired ; 

	Machine_t*	aMachine = NULL ;

	int 		allocated = 0 ;

	MachInfo_t*	machInfo = NULL ; 

	int		freePrsr = 0 ;  	

	Entry_t*	tmpEntry = NULL ; 

	int		currStartNum ;

	int		currEndNum ; 

	// Get the time for the starting of the scheduling of the job 
	ftime( &(aJob->jobStartScheduleTime) ) ; 	

	aJob->entryList.StartTraversal() ;

	for ( tmpEntry = aJob->entryList.Element() ;
	      tmpEntry ; 
	      tmpEntry = !aJob->entryList.Advance() ? aJob->entryList.Element() : NULL ) 
	{
		reqNodes = tmpEntry->numInstances ;

		currStartNum = tmpEntry->startEntryNum ;
		cout << "SN : " << currStartNum << endl ; 

		currEndNum = tmpEntry->endEntryNum ;
		cout << "EN : " << currEndNum << endl ; 

		// As long as the required number of nodes have been allocated loop
		// for this entry 

		while ( reqNodes > 0 )
		{
			// Get a machine with atleast one node free
			// The search for the machine follows the queue order embedded in
			// machine hash table 
			aMachine = machineList.GetFreeMachine( reqNodes, allocated ) ;
	
			// aMachine cannot be null since a check is made
			// in the caller function that the required number of 
			// processors are available 
	
			machInfo = aRJob->Search(aMachine) ;

			if ( machInfo == NULL )
			{
				// Allocate an entry for the machine 
				machInfo = new MachInfo_t(aMachine) ;
	
				assert ( machInfo != NULL ) ;

				aRJob->runningMachList.Insert( machInfo ) ;	
			}

			RunningEntry_t* runEntry = new RunningEntry_t( tmpEntry,
						currStartNum,currStartNum + allocated - 1 ) ; 
							
			currStartNum = currStartNum + allocated ;

			assert ( runEntry != NULL ) ;

			machInfo->entryList.Insert( runEntry ) ;

			machInfo->prsrAllocated += allocated ; 

			// For Reporting Statistics
			machInfo->initialPrsrAllocated += allocated ; 
	
			reqNodes -= allocated ;  

			// If the job has not been inserted
			// insert it into the machine
			aMachine->InsertJob( aJob ) ;   
		}			
	}

	// Make the job entry in submitted job list point to the running entry  
	aJob->runEntryPtr = aRJob ;  

	// Now insert into the running job list  
	runningList.Insert( aRJob ) ;

	cout  << "Finished Scheduling " << endl ;
	cout.flush() ;

	return 0 ;
}

int
SendScheduleMessage( Job_t* aJob, String& msgBuffer, char* hostAddr )
{
	assert( hostAddr != NULL ) ;

	int clientSock = -1;

	MessHeader_t msg(MyIPAddress) ;

	clientSock = CreateClientSocket( hostAddr, Constant::LSPPortNumber ) ;

	if ( clientSock < 0 )
	{
		return -1 ; 
	}

	msg.msgType = MSG_SCHEDULE ;

	msg.msgLen = ::strlen(msgBuffer.chars()) ;

	msg.jobId = aJob->jobId ; 

	msg.numNodes = aJob->numNodesRequired ;  

	msg.Send( clientSock ) ;

	cout << "Sending:" << ::strlen(msgBuffer.chars()) << endl << msgBuffer << endl ;
	
	if ( write( clientSock,msgBuffer.chars(),::strlen(msgBuffer.chars()) ) < 0 )  	
	{
		cerr << "Unable to send schedule message to " << hostAddr 
		     <<  sys_errlist[errno] << endl ;

		close(clientSock) ;

		return -1 ; 
	}	

	close(clientSock) ;

	return 0 ; 
}

int
BuildAndSendScheduleMessage( Job_t* aJob )
{
	assert ( aJob != NULL ) ;

	// Get the running entry pointer for the job aJob
	RunningJob_t*	aRunJob = aJob->runEntryPtr ;

	char integer[64] ; 	

	MachInfo_t*  tmpMach ;

	if ( aRunJob->runningMachList.IsEmpty() )
		return -1 ;

	aRunJob->runningMachList.StartTraversal();

	String	msg ;

	for (  tmpMach = aRunJob->runningMachList.Element() ;
	      tmpMach ; tmpMach = !aRunJob->runningMachList.Advance() ? 
			         aRunJob->runningMachList.Element() : NULL ) 
	{
		if ( tmpMach->entryList.IsEmpty() )    
			continue ;

		RunningEntry_t*  tmpentry = NULL ;
			
		tmpMach->entryList.StartTraversal();

		msg = '\0' ;

		for ( tmpentry = tmpMach->entryList.Element() ;
	      		tmpentry ; tmpentry = !tmpMach->entryList.Advance() ? 
			         tmpMach->entryList.Element() : NULL ) 
		{
			String submsg ;

			sprintf(integer,"%d %d ",tmpentry->startEntryNum,
						tmpentry->endEntryNum) ;

		       	submsg = integer ;

			Entry_t* entry = tmpentry->entryPtr ; 

			assert( entry != NULL ) ;

			submsg += entry->fileName ;

			submsg += ' ' ; 

			submsg += entry->parameters ; 

			submsg += '\n' ; 

			// To hack around the string concatenation bug 
			String tmpstr ;

			tmpstr.alloc(::strlen(msg.chars()) + ::strlen(submsg.chars())+2) ; 

			::strcpy(tmpstr,msg.chars()) ;

			::strcat(tmpstr,submsg.chars()) ;

			msg = tmpstr ; 
		}

		// Send to the machine the message 
		cout << tmpMach->machPtr->ipAddress << " " << msg << endl ; 

		SendScheduleMessage( aJob ,msg,tmpMach->machPtr->ipAddress) ;
	}

	// Scheduling completed. Get the time taken for scheduling to finish
	ftime( &(aJob->jobFinishScheduleTime) ) ; 

	return 0 ;
}
