#include <stdio.h>
#include <string.h>
#include <String.h>
#include "List.h"
#include "Functions.h"
#include "GSPJob.h"

int
Linearize( String& msg, oo_List<Job_t>& statCollect, Job_t* tmpJob )
{
	if ( statCollect.IsEmpty() )
		return -1 ;

	char number[64] ;

	if ( tmpJob == NULL )
		return -1 ; 

	RunningJob_t*	tmpRunningJob = NULL ; 

	struct timeb	currTime ;

	ftime( &currTime ) ; 

	// Put the jid first
	msg += "Job Id :" ;

	sprintf(number,"%d\n",tmpJob->jobId) ; 

	msg += number ;

	if ( tmpJob )
	{	
		struct timeb timeTaken ;

		if ( tmpJob->runEntryPtr == NULL )
		{
			// Job has not been scheduled yet
			// Report the waiting time only
			msg += "Waiting Time is " ;

			DiffTime( currTime, tmpJob->jobArrivalTime, timeTaken ) ;

			sprintf( number,"%d:%d\t",timeTaken.time,timeTaken.millitm ) ;
			
			msg += number ; 	

			msg += "\n" ;

			return 0 ; 
		}

		// If the job is running, report the entries also

		// Find the amount of time the process has run so far
		DiffTime( currTime, tmpJob->jobFinishScheduleTime, timeTaken ) ;  

		msg += "Job has run for " ;  

		sprintf( number,"%d:%d\t",timeTaken.time,timeTaken.millitm ) ;

		msg += number ;

		msg += ".\n" ;

		Linearize( msg, tmpJob->entryList ) ; 

		msg += "\n" ;

		return 0 ; 
	}

	return 0 ; 
}

int
Linearize( String& msg, oo_List<Job_t>& statCollect )
{
	if ( statCollect.IsEmpty() )
		return -1 ;

	int jid ; 

	Job_t* tmpJob = NULL ;

	for ( statCollect.StartTraversal() , tmpJob = statCollect.Element() ;
		tmpJob ;
		tmpJob = !statCollect.Advance() ? statCollect.Element() : NULL ) 
	{
		String submsg ;

		Linearize( submsg, statCollect, tmpJob ) ;

		String tmpstr ;

		tmpstr.alloc(::strlen(msg.chars()) + ::strlen(submsg.chars())+2) ;

		::strcpy(tmpstr,msg.chars()) ;

		::strcat(tmpstr,submsg.chars()) ;

		// cout << "--------------------- " <<  submsg << endl  ;

		// cout << "--------------------- " << tmpstr << endl ; 

		msg = tmpstr ;
	}
							
	return 0 ;
}
