#include <iostream.h>
#include <fstream.h>
#include <assert.h>
#include <String.h>
#include <sys/time.h>
#include <stdlib.h>
#include <math.h>

// ----------------------------------------------------------------------------
extern "C" long random(void) ;
extern "C" int srandom(int) ; 
extern "C" int sleep(int) ; 	


inline void
usage()
{	
	cerr << "jfind <GSP Host Name> <Max degree of Parallelism> <jobs to be submitted> <arrival rate> <job submission dir>" 
	     << endl ;
}

void
main(int argc, char* argv[])
{
	if ( argc != 6 ) 
	{
		usage() ;
		exit(1) ;
	}

	String jobstr[4] ; 

	String cmd = "/u/grad/ramasamy/736.block/c/gsp/submit "; 	

	cmd += "-f /tmp/job -s " ;

	cmd += argv[1] ;

	cmd += " -d " ;

	cmd += argv[5] ;

	// small job
	jobstr[0] += "1 find /u/grad/ramasamy -name xx -print" ;

	// long job
	jobstr[1] += "1 find /p/src/freeware -name xx -print" ;

	// long medium job
	jobstr[2] += "1 find /usr/unsup -name xx -print" ;

	// a very long job 
	// jobstr[3] += "1 find /usr -name xx -print" ;
	jobstr[3] += "1 find /u/grad/ramasamy/private -name xx -print" ;

	srandom(time(0)) ;

	for ( int j = 0 ; j < atoi(argv[3]) ; j++ )
	{
		// Create a new jobfile 
		ofstream fout("/tmp/job") ; ;  

		if ( !fout )
		{
			cerr << "Unable to open a job file" << endl ;
			exit(1) ;
		}	

		int parallel = random() % atoi(argv[2]) + 1 ;  

		fout << 60 * 5 * parallel << endl ;

		for( int i = 1 ; i <= parallel ; i++ )
		{
			// choose a job	
			int j = random() % 4 ;

			fout << jobstr[j] << endl ;
		}
	
		fout.flush() ; 

		fout.close() ;

		cout << cmd << endl ;

		system( cmd.chars() ) ;

		sleep(atoi(argv[4])) ; 
	}
}

