#include <iostream.h>
#include <stdio.h>
#include <fstream.h>
#include <assert.h>
#include <String.h>
#include <sys/time.h>
#include <stdlib.h>
#include <math.h>
#include <ACG.h>
#include <Poisson.h>

// ----------------------------------------------------------------------------
extern "C" long random(void) ;
extern "C" int srandom(int) ; 
extern "C" int sleep(int) ; 	

extern	void		SetProcessMeanExp(int) ;
extern	unsigned	GenerateProcessExp(int, double) ;
extern	void		SetJobMean(int) ;
extern	unsigned	GenerateJob() ;
extern	void		SetDemandMean95(int) ;
extern	void		SetDemandMean5(int) ;
extern	unsigned	GenerateJobDemand() ; 

int
GenerateNo( ofstream& fout, int numNodes, int atime )
{
	char cmdstr[512] ;
	
	// Generate the intermediate nodes
	for ( int i = 1 ; i < numNodes ; i++ )
	{
		sprintf(cmdstr,"1 /u/grad/ramasamy/736.block/swbd/no %d", atime ) ;

		fout << cmdstr << endl ;
	}

	fout.flush() ; 

	return 1 ;
}


		

inline void
usage()
{	
	cerr << "jring <GSP Host Name> <Max degree of Parallelism> <jobs to be submitted> <mean arrival rate> <mean process> <P(processes = processors)> <Demand 95% Mean> <Demand 5% Mean> <submission dir>" 
	     << endl ;
}

void
main(int argc, char* argv[])
{
	if ( argc != 10 ) 
	{
		usage() ;
		exit(1) ;
	}

	String cmd = "/u/grad/ramasamy/736.block/c/gsp/submit "; 	

	cmd += "-f /tmp/job -s " ;

	cmd += argv[1] ;

	cmd += " -d " ;

	cmd += argv[9] ;

	srandom(12341) ;

	// Set the mean arrival rate of jobs
	assert( atoi(argv[4]) > 10 ) ;

	SetJobMean( atoi(argv[4]) ) ;

	assert( atoi(argv[5]) > 1 ) ;

	SetProcessMeanExp( atoi(argv[5]) ) ;

	int numNodes = atoi(argv[2]) ; 

	double prob = atof(argv[6]) ; 

	assert( prob >= 0 && prob <= 1 ) ;

	SetDemandMean95( atoi(argv[7]) ) ;

	SetDemandMean5( atoi(argv[8]) ) ;

	for ( int j = 0 ; j < atoi(argv[3]) ; j++ )
	{
		// Create a new jobfile 
		ofstream fout("/tmp/job") ;   

		if ( !fout )
		{
			cerr << "Unable to open a job file" << endl ;
			exit(1) ;
		}	

		// Generate the set of processes for a job
		int parallel = GenerateProcessExp( numNodes, prob ) ;  

		cout << "Number of Processes " << parallel << endl ;

		// Generate Demand for the job
		int	timetorun = GenerateJobDemand() ; 

		cout << "Job Demand " << timetorun << endl ;

		fout << timetorun * parallel << endl ;

		GenerateNo( fout, parallel, timetorun ) ;

		fout.close() ;

		cout << cmd << endl ;

		system( cmd.chars() ) ;

		int sleep_time = GenerateJob() ; 

		cout << "Sleep Time " << sleep_time << endl ;

		sleep( sleep_time ) ; 
	}
}
