#include <iostream.h>
#include <stdlib.h>
#include <ACG.h>
#include <Geom.h>
#include <Poisson.h>

static	ACG 		gen1(379378) ;

static 	ACG 		gen2(131292) ;

static 	ACG 		gen3(383839) ;

static 	ACG 		gen4(23834230) ;

static	ACG		gen5(23732323) ;

static	ACG		gen6(22382383) ;

static	ACG		gen7(29292923) ;

static	Poisson		poisson(1,&gen2) ;

static  Poisson		jobPoisson(1,&gen3) ;

static	Poisson		d95Poisson(1,&gen5) ;

static	Poisson		d5Poisson(1,&gen6) ;

static	Geometric	geom(0.5,&gen4 ) ;

void
SetProcessMeanExp(int mean)
{
	poisson.mean( double(mean) ) ;
}

unsigned 
GenerateProcessExp(int numNodes,double probProcessors)
{
	// Generate a random number between 0 and 1  
	double p = gen1.asDouble() ;

	if ( p <= probProcessors )
	{
		return numNodes ;
	}

	int processes = unsigned(poisson()) ;

	if ( processes >= numNodes )
		return numNodes ;

	return processes ;
}

void
SetJobMean(int mean)
{
	jobPoisson.mean( double(mean) ) ;
}
	
unsigned 
GenerateJob()
{
	return unsigned(jobPoisson()) ;
}

void
SetProcessMeanGeometric(int mean)
{
	geom.mean( double( 1/double(mean) ) ) ;
}

unsigned 
GenerateProcessGeometric(int numNodes,double probProcessors)
{
	// Generate a random number between 0 and 1  
	double p = gen4.asDouble() ;

	if ( p <= probProcessors )
	{
		return numNodes ;
	}

	int processes = unsigned(geom()) ;

	if ( processes >=  numNodes )
		return numNodes ;

	return processes ;
}

void
SetDemandMean95(int mean)
{
	d95Poisson.mean( double(mean) ) ;
}

inline unsigned
Generate95Demand()
{
	return unsigned( d95Poisson() ) ;
}

void
SetDemandMean5(int mean)
{
	d5Poisson.mean( double(mean) ) ;
}

inline int
Generate5Demand()
{
	return unsigned( d5Poisson() ) ;
}

unsigned
GenerateJobDemand()
{
	double p = gen7.asDouble() ;

	if ( p <= 0.95 )
		return Generate95Demand() ;

	return Generate5Demand() ;
}
