#include <iostream.h>
#include <String.h>

#include "Functions.h"
#include "Message.h"
#include "List.h"
#include "LSPStat.h"

extern oo_List<LSPStat_t>       jobDetails ;

int
SingleJobQuery( int querySock, int jobId , char* myIPAddress)
{
	String ansQuery ;

	signal_lock() ;

	if ( Linearize( ansQuery, jobDetails, jobId ) < 0 )
	{
		char number[64] ;	// AMIT - Can make this a #define'd var

		ansQuery = "Job " ;

		sprintf(number,"%d ",jobId ) ;

		ansQuery += number ;  

		ansQuery += "does not exist in \t" ;

		char* hostName = GetHostName() ;	

		ansQuery += hostName ;  
		
		ansQuery += "." ; 
	}

	// Read and write system calls are automatically
	// restarted. So we don't block them 

	signal_unlock() ;

	MessHeader_t message(myIPAddress) ;

	const char* answer = ansQuery.chars() ;

	cout << answer << endl ; 

	message.ConstructQueryAnswerMessage( ::strlen(answer) ) ;   	

	if ( message.Send( querySock ) < 0 )
	{
		cerr << "Error sending message header to single job query answer : "
		     << sys_errlist[errno] << endl ;
		
		return -1 ; 
	}	
	
	// Send the answer over the querysock
	if ( write( querySock, answer, ::strlen(answer) ) < 0 )
	{
		cerr << "Error sending answer to single job query : "
		     << sys_errlist[errno] << endl ;

		return -1 ; 
	}

	return 0 ;
}

int
AllJobQuery( int querySock, char* myIPAddress)
{
	String ansQuery ;

	signal_lock() ;

	if ( Linearize( ansQuery, jobDetails ) < 0 )
	{
		ansQuery = "No jobs are running in " ;

		char* hostName = GetHostName() ;	

		cout << hostName << endl ;

		ansQuery += ( hostName != NULL ? hostName : "\0" ) ;    
	}

	// Read and write system calls are automatically
	// restarted. So we don't block them 

	signal_unlock() ;

	MessHeader_t message(myIPAddress) ;

	const char* answer = ansQuery.chars() ;

	cout << answer << endl ; 

	message.ConstructQueryAnswerMessage(::strlen(answer)) ;   	

	if ( message.Send( querySock ) < 0 )
	{
		cerr << "Error sending message header to all job query answer : "
		     << sys_errlist[errno] << endl ;
	

		return -1 ; 
	}	
	
	// Send the answer over the querysock
	if ( write( querySock, answer, ::strlen(answer) ) < 0 )
	{
		cerr << "Error sending answer to all job query : "
		     << sys_errlist[errno] << endl ;

		return -1 ; 
	}

	return 0 ;
}

	
	
