#include <iostream.h> 
#include <fstream.h>
#include <String.h>
#include "LSP.h"
#include "List.h"

extern	int			GSPportNumber ;
extern	int			LSPportNumber ;
extern	char			GSPipAddress[] ;
extern	char			MyIPAddress[] ;

extern	JobTable		LocalHostJobs ;
extern	oo_List<LSPStat_t>	jobDetails ;


int
Dispatch( int jobId, int startNum, int endNum, String& fileName, String& parameters)  
{
	// job Id has already been inserted into JobTable	
	for ( int i = startNum ; i <= endNum ; i++ )
	{
		int pid = fork() ;

		// Parent process
		if ( pid < 0 )
		{
			cerr << "Forking Failed: " << sys_errlist[errno] << endl ;

			KillJobWithoutLock( jobId ) ;

			return -1 ;
		}
		else if ( pid > 0 )	// Parent
		{
			LSPStat_t* tmpLSPStat = new LSPStat_t ;

			if ( tmpLSPStat != NULL )
			{
				ftime( &(tmpLSPStat->scheduleTime) ) ; 

				tmpLSPStat->processId = pid ;

				tmpLSPStat->entryNum = i ;

				tmpLSPStat->fileName = fileName ;

				tmpLSPStat->parameters = parameters ;

				tmpLSPStat->status = RUNNING ; 

				jobDetails.Insert( tmpLSPStat ) ; 
			}

			LocalHostJobs.InsertProcessId( jobId, pid ) ;
		}
		else if ( pid == 0 )	// Child
		{
			// Enable all signals in the child
			// signal_unlock() ;

			String tmp(fileName) ;  

			tmp += ' ' ;

			tmp += parameters ;
		
			char	shell[] = "/bin/sh" ; 

			char	options[] = "-c" ;

			char*	param[4] ;

			param[0] = shell ;

			param[1] = options ;

			param[2] = tmp.chars() ;

			param[3] = (char *)NULL ; 

			cout << shell << " " << options << " " << tmp << " " << endl ;

			// We got to parse the shell stuff here 	
			// Child Process  
			if ( execv( shell, param ) < 0 )
			{
				cerr << "Unable to exec " << sys_errlist[errno] << endl ; 

				// Log the error that the execvp failed 
				// How to handle the errors in this case

				exit(1) ;
			}
		}
	}

	return 0 ;
}

int
ParseAndScheduleSingleEntry( int jobId, String& entry)
{
	int pos = 0 ;
	int follow = 0 ;

	String	fileName ;
	String	startNum ; 	
	String	endNum ; 	
	String	parameters ; 

	// TO DO : The syntax has changed to 
	// start entry end entry filename parameters

	// Get the start number of entry 
	follow = entry.index( ' ',pos ) ;
	startNum = entry( pos, follow - pos ) ;
	pos = follow + 1 ;

	// Get the end number of entry 
	follow = entry.index( ' ',pos ) ;
	endNum = entry( pos, follow - pos ) ;
	pos = follow + 1 ;

	// Get the file name 
	follow = entry.index( ' ', pos ) ;
	fileName = entry( pos, follow - pos ) ; 
	pos = follow + 1 ;

	// Get the parameters  
	parameters = entry( pos, entry.length() - pos ) ;

	cout << fileName << parameters << endl; 

	return Dispatch( jobId, atoi(startNum.chars()), 
				atoi(endNum.chars()), fileName, parameters ) ;
}

int
SplitMessageAndSchedule( int jobId, String& message)
{
	int pos = 0 ;
	int follow = 0 ;

	String	entry ;  		

	signal_lock() ;

	LocalHostJobs.InsertJobId( jobId ) ; 

	while ( ( follow = message.index('\n',pos) ) > 0 ) 
	{
		entry = message(pos,follow-pos) ;   	

		// TO DO : Cleanup might be required if for removing
		// to remove jobId 
		if ( ParseAndScheduleSingleEntry( jobId, entry ) < 0 )
		{
			signal_unlock() ;

			return -1 ;
		}

		pos = follow + 1 ; 
	}

	signal_unlock() ;

	return 0 ;
}

