#include <iostream.h>
#include "LSP.h"
#include "LSPStat.h"
#include "List.h"

extern int                      GSPportNumber ;
extern int                      LSPportNumber ;
extern char                     GSPipAddress[] ;
extern char                     MyIPAddress[] ;

extern JobTable                 LocalHostJobs ;
extern oo_List<LSPStat_t>	jobDetails ;

int
ResumeORSuspendJob( int jobId, int flag )
{
	int processIds[Constant::MAX_PROCESSORS] ;

	LSPStat_t*	lspStat = NULL ;

	signal_lock() ;

	int numProcess = LocalHostJobs.GetProcessId( jobId, processIds ) ;

	// Check whether it is a valid jobId for which at least a process exist
	if ( numProcess <= 0 )
	{
		signal_unlock() ;

		return -1 ;
	}

	for ( int i = 0 ; i < numProcess ; i++ )
	{
		lspStat = Search( jobDetails, processIds[i] ) ;

		assert( lspStat != NULL ) ;

		// Issue the STOP signal for each of the process
		if ( flag == SUSPEND ) 
		{
			kill(processIds[i],SIGSTOP) ;

			lspStat->status = SUSPENDED ; 
		}
		else if ( flag == RESUME )
		{
			kill(processIds[i],SIGCONT) ;

			lspStat->status = RUNNING ; 
		}
	}

	// Traverse the list in order to update the status of 
	// process entries
	signal_unlock() ;

	return 0 ;
}
