#include <stdio.h>
#include "PJobTable.h"

int
PersistentJobTable::Save()
{
	if ( IsFileInitialized() )
	{
		return FILE_NOT_INITIALIZED ;
	}

	// Open the file for writing
	// Note there is a possibility that the
	// system may crash when it has opened the
	// file for writing and crashed before
	// it writes the file

	FILE*	file = fopen(NameOfFile,"w") ;  

	if ( !file )
	{
		return FILE_OPEN_ERROR ;
	}

	// Write the signature of this file 
	// TO DO 

	// Traverse the Job Id Table and Process Id Table
	// in order to save them into the file 

	for ( int i = 0 ; i < Constant::MAX_JOBS ; i++ )
	{
		if ( JobIdTable[i] ) 
		{
			fprintf(file,"%d ", JobIdTable[i] ) ;

			for ( int j = 0 ; j < Constant::MAX_PROCESSORS ; j++ )
			{
				if ( ProcessIdTable[i][j] )
				{
					fprintf(file,"%d ", ProcessIdTable[i][j]) ;
				}	
			}

			fprintf(file,"\n") ;
		}	
	}

	fclose(file) ;

	return 0 ;
}

						
int
PersistentJobTable::Restore()
{
	if ( IsFileInitialized() )
	{
		return FILE_NOT_INITIALIZED ;
	}

	FILE*	file = fopen(NameOfFile,"r") ;  

	if ( !file )
	{
		return FILE_OPEN_ERROR ;
	}

	// Read the signature of this file
	// TO DO

	// Read the job id, followed by a set of process ids
	// This sequence is repeated until eof is reached

	char buf[12] ; 

	int JobIndex = 0 ;

	int ProcessIndex = 0 ; 

	enum {JOB_ID_READ, PROCESS_ID_READ } fsm_state ;

	char c ;

	while ( !feof(file) )
	{
		switch (fsm_state)
		{
			case JOB_ID_READ :

				fscanf(file,"%d",&JobIdTable[JobIndex]) ; 

				fsm_state = PROCESS_ID_READ ;

				break ;

			case PROCESS_ID_READ :

				// Check for the max size overflow 	
				// TO DO
				while ( (c = fgetc(file)) != '\n' )
				{
					ungetc(c,file) ;

					fscanf(file,"%d", 
					&ProcessIdTable[JobIndex][ProcessIndex++] ) ;   
				}

				fsm_state = JOB_ID_READ ;
			
				break ;
		}

		// Check for the Job Index Overflow 
		// TO DO
		JobIndex++ ; 
	}
}
