#if !defined(__FUNCTIONS_H)
#define	__FUNCTIONS_H

#include <sys/types.h>
#include <sys/timeb.h>

extern "C" {

	int read() ;
	int write() ;
	int socket() ;
	int bind() ;
	int listen() ;
	int connect() ;
	int accept() ;
	int select() ;
	int sleep() ;
	int close() ;
	int fork() ;
	int wait() ; 
	int execl() ;
	int sigblock() ;
	int sigsetmask() ;
	int setsockopt() ;
	int wait3() ;
	int execvp() ;
	int unlink() ; 
	void bzero() ;
	void bcopy() ; 
	void ftime() ;	
	int getopt() ;
	int gethostname() ;
} ;

struct hostent* 
OurGetHostByName( const char* hostName ) ;

struct hostent* 
OurGetHostByAddr( const char* hostAddr, int Length, int addrType) ;

int
CheckIPAddress( const char* hostNameORAddr ) ;

struct hostent*
OurGetHostEntry( const char* hostNameORAddr ) ;

char*
OurGetHostName( const char* hostNameORAddr ) ;

char*
OurGetHostAddress( const char* hostNameORAddr ) ;

char*
GetHostName() ;

int
CreateServerSocket( int portNumber ) ; 

int
CreateClientSocket( const char* hostNameORAddr, int servPortNumber ) ;


int
GetConfigurationInfo( const char* configFileName, const char* hostNameORAddr ) ;

int
GetIPAddress( const char* configFileName,const char* hostNameORAddr,char* hostAddr) ;

int
CheckValidInteger( const char* numString) ;

int
CheckFileExistence( const char* fileName ) ;

void
signal_lock() ;

void
signal_unlock() ; 

void
DiffTime( struct timeb&, struct timeb&, struct timeb& ) ;  

int
ValidatePortNumber( const char* portNumber, int selection ) ;

#endif 

