#if !defined(__LSPSTAT_H)
#define	__LSPSTAT_H

#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <String.h>	 
#include "List.h"

enum PStatus_t
{
	SUSPENDED,
	RUNNING
} ;

struct LSPStat_t
{
	pid_t		processId ;

	int		entryNum ; 
		
	String		fileName ;

	String		parameters ; 		

	struct timeb	scheduleTime ; 	

	PStatus_t	status ; 
} ;

LSPStat_t*
Search( oo_List<LSPStat_t>&, pid_t ) ;

int
Delete( oo_List<LSPStat_t>&, pid_t ) ;

void
Print( oo_List<LSPStat_t>& ) ;

int
Linearize( String&, oo_List<LSPStat_t>&, int jobId ) ;

int
Linearize( String&, oo_List<LSPStat_t>& ) ;

const	int	SUSPEND	= 0 ;
const	int	RESUME	= 1 ;

#endif 
