#include "JobTable.h"
#include "Persist.h"

#if !defined(__PJOB_TABLE_H)
#define	__PJOB_TABLE_H

class PersistentJobTable : public virtual JobTable, public virtual Persistence
{
	public :

		PersistentJobTable() ;

		PersistentJobTable(const char* FileName) ;

		virtual
		~PersistentJobTable() ;

		virtual
		int
		Save() ;

		virtual
		int
		Restore() ;

		// Error Codes
		static  int     FILE_NOT_INITIALIZED    = -1 ;
		static  int     FILE_OPEN_ERROR         = -2 ;
		static  int     FILE_READ_ERROR         = -3 ;
		static  int     FILE_WRITE_ERROR        = -4 ;
} ;

inline
PersistentJobTable::PersistentJobTable() : Persistence(), JobTable()  
{
}

inline
PersistentJobTable::PersistentJobTable(const char* FileName) : 
		Persistence(FileName), JobTable()
{
}

inline
PersistentJobTable::~PersistentJobTable()
{
}

#endif 

