#include "Error.h"

#if !defined( __PERSIST_H )
#define	__PERSIST_H

class Persistence
{
	public :

		Persistence() ;

		Persistence(const char* FileName) ;

		virtual
		~Persistence() ;

		char*
		GetFileName() ;

		int
		SetFileName(const char* FileName ) ;

		int
		IsFileInitialized() ;

		virtual 
		int
		Save() = 0 ;

		virtual
		int
		Restore() = 0 ;

	protected :

		char* NameOfFile ; 

} ; 

inline
Persistence::Persistence()
{
	NameOfFile = NULL ;
}

inline
Persistence::Persistence(const char* FileName)
{
	if ( FileName )	
	{
		NameOfFile = new char [ ::strlen(FileName) + 1 ] ;

		if ( NameOfFile )
		{
			::strcpy(NameOfFile,FileName) ;
		}
	}	
}

inline
Persistence::~Persistence()
{
	if ( NameOfFile )
		delete [] NameOfFile ;
}

inline
char*
Persistence::GetFileName()
{
	return NameOfFile ;
}	

inline
int
Persistence::SetFileName(const char* FileName)
{
	if ( FileName )	
	{
		NameOfFile = new char [ ::strlen(FileName) + 1 ] ;

		if ( NameOfFile )
		{
			::strcpy(NameOfFile,FileName) ;
		}
		else
			return Error::MEMORY_ALLOCATION_ERROR ; 
	}	

	return 0 ;
}
		
inline
int
Persistence::IsFileInitialized()
{
	return NameOfFile ? 1 : 0 ;
}


#endif 
